Pool Info (Multi)
Retrieves comprehensive overview metrics for one or more Orca Whirlpool pools in a single request. For each requested pool, the endpoint returns pricing, liquidity, volume, fee, and token metadata sourced from the pre-calculated pool details view.
GET
https://api.cambrian.org/solana/orca/pool
Parameters
pool_addresses* (string)
Comma-separated pool addresses within the same DEX. Example: addr1,addr2,addr3
Responses
Code
Description
200
Successful response
Media type: application/vnd.cambrian.table.v1.0.0+json
[
{
"columns": [
{
"name": "poolAddress",
"type": "String"
},
{
"name": "createdAt",
"type": "DateTime('UTC')"
},
{
"name": "token0Address",
"type": "String"
},
{
"name": "token0Symbol",
"type": "String"
},
{
"name": "token0Decimals",
"type": "UInt8"
},
{
"name": "token1Address",
"type": "String"
},
{
"name": "token1Symbol",
"type": "String"
},
{
"name": "token1Decimals",
"type": "UInt8"
},
{
"name": "tickSpacing",
"type": "Int32"
},
{
"name": "tokenVaultA",
"type": "String"
},
{
"name": "tokenVaultB",
"type": "String"
},
{
"name": "sqrtPriceX64",
"type": "UInt128"
},
{
"name": "currentTick",
"type": "Nullable(Float64)"
},
{
"name": "price",
"type": "Nullable(Float64)"
},
{
"name": "tvlToken0",
"type": "Nullable(Float64)"
},
{
"name": "tvlToken1",
"type": "Nullable(Float64)"
},
{
"name": "tvl",
"type": "Nullable(Float64)"
},
{
"name": "volume24h",
"type": "Nullable(Float64)"
},
{
"name": "fees24hToken0",
"type": "Nullable(Float64)"
},
{
"name": "fees24hToken1",
"type": "Nullable(Float64)"
},
{
"name": "fees24h",
"type": "Nullable(Float64)"
},
{
"name": "apr24h",
"type": "Nullable(Float64)"
},
{
"name": "priceVolatility",
"type": "Nullable(Float64)"
},
{
"name": "utilization24h",
"type": "Nullable(Float64)"
},
{
"name": "factoryAddress",
"type": "String"
},
{
"name": "factoryName",
"type": "String"
}
],
"data": [
[
"Czfq3xZZDmsdGdUyrNLtRhGc47cXcZtLG4crryfu44zE",
"2023-06-30T06:20:58+00:00",
"So11111111111111111111111111111111111111112",
"SOL",
9,
"EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
"USDC",
6,
4,
"EUuUbDcafPrmVTD5M6qoJAoyyNbihBhugADAxRMn5he9",
"2WLWEuKDgkDUccTpbwYp1GToYktiSB1cXvreHUwiSUVP",
5848524942348921000,
-22976,
100.52017772999893,
106251.8177087,
14458065.399568,
25178142.324406184,
373835068.28368795,
738.52781677,
75019.209557,
149534.06363429173,
216.77506038088424,
2.6519689873337233,
50.148333333333326,
"whirLbMiicVdio4qvUfM5KAg6Ct8VwpYzGff3uctyCc",
"Orca"
]
],
"rows": 1
}
]
400
Bad Request: Invalid request parameters or malformed request.
401
Unauthorized: Missing or invalid API key. Include X-API-Key header with your request.
403
Forbidden: Invalid API key or insufficient permissions to access this resource.
404
Not Found: Endpoint or resource does not exist.
408
Request Timeout: Request took too long to process. Try again.
500
Internal Server Error: An unexpected error occurred while processing your request.
503
Service Unavailable: The server is temporarily unable to handle the request. Please try again later.
Examples
1. Retrieve metrics for a single Orca pool
This example queries the SOL/USDC Orca Whirlpool for its current price, TVL, volume, and fee metrics.
curl
curl -X GET "https://api.cambrian.org/solana/orca/pool?pool_addresses=Czfq3xZZDmsdGdUyrNLtRhGc47cXcZtLG4crryfu44zE" \
-H "X-API-Key: YOUR_API_KEY" \
-H "Content-Type: application/json"
Response:
JSON
1[
2 {
3 "columns": [
4 {
5 "name": "poolAddress",
6 "type": "String"
7 },
8 {
9 "name": "createdAt",
10 "type": "DateTime('UTC')"
11 },
12 {
13 "name": "token0Address",
14 "type": "String"
15 },
16 {
17 "name": "token0Symbol",
18 "type": "String"
19 },
20 {
21 "name": "token0Decimals",
22 "type": "UInt8"
23 },
24 {
25 "name": "token1Address",
26 "type": "String"
27 },
28 {
29 "name": "token1Symbol",
30 "type": "String"
31 },
32 {
33 "name": "token1Decimals",
34 "type": "UInt8"
35 },
36 {
37 "name": "tickSpacing",
38 "type": "Int32"
39 },
40 {
41 "name": "tokenVaultA",
42 "type": "String"
43 },
44 {
45 "name": "tokenVaultB",
46 "type": "String"
47 },
48 {
49 "name": "sqrtPriceX64",
50 "type": "UInt128"
51 },
52 {
53 "name": "currentTick",
54 "type": "Nullable(Float64)"
55 },
56 {
57 "name": "price",
58 "type": "Nullable(Float64)"
59 },
60 {
61 "name": "tvlToken0",
62 "type": "Nullable(Float64)"
63 },
64 {
65 "name": "tvlToken1",
66 "type": "Nullable(Float64)"
67 },
68 {
69 "name": "tvl",
70 "type": "Nullable(Float64)"
71 },
72 {
73 "name": "volume24h",
74 "type": "Nullable(Float64)"
75 },
76 {
77 "name": "fees24hToken0",
78 "type": "Nullable(Float64)"
79 },
80 {
81 "name": "fees24hToken1",
82 "type": "Nullable(Float64)"
83 },
84 {
85 "name": "fees24h",
86 "type": "Nullable(Float64)"
87 },
88 {
89 "name": "apr24h",
90 "type": "Nullable(Float64)"
91 },
92 {
93 "name": "priceVolatility",
94 "type": "Nullable(Float64)"
95 },
96 {
97 "name": "utilization24h",
98 "type": "Nullable(Float64)"
99 },
100 {
101 "name": "factoryAddress",
102 "type": "String"
103 },
104 {
105 "name": "factoryName",
106 "type": "String"
107 }
108 ],
109 "data": [
110 [
111 "Czfq3xZZDmsdGdUyrNLtRhGc47cXcZtLG4crryfu44zE",
112 "2023-06-30T06:20:58+00:00",
113 "So11111111111111111111111111111111111111112",
114 "SOL",
115 9,
116 "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
117 "USDC",
118 6,
119 4,
120 "EUuUbDcafPrmVTD5M6qoJAoyyNbihBhugADAxRMn5he9",
121 "2WLWEuKDgkDUccTpbwYp1GToYktiSB1cXvreHUwiSUVP",
122 5848524942348921000,
123 -22976,
124 100.52017772999893,
125 106251.8177087,
126 14458065.399568,
127 25178142.324406184,
128 373835068.28368795,
129 738.52781677,
130 75019.209557,
131 149534.06363429173,
132 216.77506038088424,
133 2.6519689873337233,
134 50.148333333333326,
135 "whirLbMiicVdio4qvUfM5KAg6Ct8VwpYzGff3uctyCc",
136 "Orca"
137 ]
138 ],
139 "rows": 1
140 }
141]
2 {
3 "columns": [
4 {
5 "name": "poolAddress",
6 "type": "String"
7 },
8 {
9 "name": "createdAt",
10 "type": "DateTime('UTC')"
11 },
12 {
13 "name": "token0Address",
14 "type": "String"
15 },
16 {
17 "name": "token0Symbol",
18 "type": "String"
19 },
20 {
21 "name": "token0Decimals",
22 "type": "UInt8"
23 },
24 {
25 "name": "token1Address",
26 "type": "String"
27 },
28 {
29 "name": "token1Symbol",
30 "type": "String"
31 },
32 {
33 "name": "token1Decimals",
34 "type": "UInt8"
35 },
36 {
37 "name": "tickSpacing",
38 "type": "Int32"
39 },
40 {
41 "name": "tokenVaultA",
42 "type": "String"
43 },
44 {
45 "name": "tokenVaultB",
46 "type": "String"
47 },
48 {
49 "name": "sqrtPriceX64",
50 "type": "UInt128"
51 },
52 {
53 "name": "currentTick",
54 "type": "Nullable(Float64)"
55 },
56 {
57 "name": "price",
58 "type": "Nullable(Float64)"
59 },
60 {
61 "name": "tvlToken0",
62 "type": "Nullable(Float64)"
63 },
64 {
65 "name": "tvlToken1",
66 "type": "Nullable(Float64)"
67 },
68 {
69 "name": "tvl",
70 "type": "Nullable(Float64)"
71 },
72 {
73 "name": "volume24h",
74 "type": "Nullable(Float64)"
75 },
76 {
77 "name": "fees24hToken0",
78 "type": "Nullable(Float64)"
79 },
80 {
81 "name": "fees24hToken1",
82 "type": "Nullable(Float64)"
83 },
84 {
85 "name": "fees24h",
86 "type": "Nullable(Float64)"
87 },
88 {
89 "name": "apr24h",
90 "type": "Nullable(Float64)"
91 },
92 {
93 "name": "priceVolatility",
94 "type": "Nullable(Float64)"
95 },
96 {
97 "name": "utilization24h",
98 "type": "Nullable(Float64)"
99 },
100 {
101 "name": "factoryAddress",
102 "type": "String"
103 },
104 {
105 "name": "factoryName",
106 "type": "String"
107 }
108 ],
109 "data": [
110 [
111 "Czfq3xZZDmsdGdUyrNLtRhGc47cXcZtLG4crryfu44zE",
112 "2023-06-30T06:20:58+00:00",
113 "So11111111111111111111111111111111111111112",
114 "SOL",
115 9,
116 "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
117 "USDC",
118 6,
119 4,
120 "EUuUbDcafPrmVTD5M6qoJAoyyNbihBhugADAxRMn5he9",
121 "2WLWEuKDgkDUccTpbwYp1GToYktiSB1cXvreHUwiSUVP",
122 5848524942348921000,
123 -22976,
124 100.52017772999893,
125 106251.8177087,
126 14458065.399568,
127 25178142.324406184,
128 373835068.28368795,
129 738.52781677,
130 75019.209557,
131 149534.06363429173,
132 216.77506038088424,
133 2.6519689873337233,
134 50.148333333333326,
135 "whirLbMiicVdio4qvUfM5KAg6Ct8VwpYzGff3uctyCc",
136 "Orca"
137 ]
138 ],
139 "rows": 1
140 }
141]
x402 Payment Option
This endpoint supports pay-per-use access via the x402 payment protocol (v2): pay $0.05 USDC per request using blockchain micropayments. No API key required.
Quickstart (Typescript)
bash
npm install @x402/fetch @x402/evm viem
TypeScript
1import { x402Client } from "@x402/core/client";
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/solana/orca/pool"
11);
12const data = await response.json();
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/solana/orca/pool"
11);
12const data = await response.json();
Quickstart (Python)
bash
pip install "x402[httpx]"
Python
1import asyncio, os
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/solana/orca/pool")
13 print(response.json())
14asyncio.run(main())
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/solana/orca/pool")
13 print(response.json())
14asyncio.run(main())
Payment Flow
- Send a normal request to the endpoint (no API key needed)
- Server returns 402 Payment Required with payment details
- The x402 SDK automatically signs a payment authorization with your wallet
- The SDK resubmits the request with the signed payment
- Server verifies payment and returns the API response
The x402 SDK handles steps 2 through 5 automatically.
Network: Base (chain ID 8453) | Currency: USDC | Price: $0.05 per request